package org.mercury_im.messenger.core.di.module;

import org.mercury_im.messenger.core.SchedulersFacade;
import org.mercury_im.messenger.core.data.repository.Repositories;
import org.mercury_im.messenger.core.store.message.MercuryMessageStore;
import org.mercury_im.messenger.core.store.message.MercuryMessageStoreFactory;

import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;

@Module
public class RxMercuryMessageStoreFactoryModule {

    @Provides
    @Singleton
    static MercuryMessageStoreFactory provideMessageStoreFactory(Repositories repositories, SchedulersFacade schedulers) {

        return account -> new MercuryMessageStore(account,
                repositories.getPeerRepository(),
                repositories.getDirectChatRepository(),
                repositories.getMessageRepository(),
                schedulers);
    }
}
