package org.mercury_im.messenger.core.xmpp.state;

import org.mercury_im.messenger.core.xmpp.MercuryConnection;

import java.util.UUID;

import lombok.EqualsAndHashCode;
import lombok.ToString;
import lombok.Value;
import lombok.With;

@Value
@ToString
@EqualsAndHashCode
public class ConnectionState {

    UUID id;
    MercuryConnection connection;
    @With
    ConnectivityState connectivity;
    @With
    boolean authenticated;
    @With
    boolean resumed;

    public ConnectionState(UUID id, MercuryConnection connection, ConnectivityState connectivity, boolean authenticated, boolean resumed) {
        this.id = id;
        this.connection = connection;
        this.connectivity = connectivity;
        this.authenticated = authenticated;
        this.resumed = resumed;
    }
}
